VERSION 5.00
Begin VB.UserControl Shangle 
   CanGetFocus     =   0   'False
   ClientHeight    =   240
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   240
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Marlett"
      Size            =   12
      Charset         =   2
      Weight          =   500
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   MousePointer    =   8  'Size NW SE
   ScaleHeight     =   240
   ScaleWidth      =   240
   ToolboxBitmap   =   "Shangle.ctx":0000
End
Attribute VB_Name = "Shangle"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *************************************************************
'  Copyright 1999, Karl E. Peterson and Phil Weber
'  All Rights Reserved.  http://www.mvps.org/vb/
' *************************************************************
'  The term "shangle," by the way, was coined by Alan Cooper
'  in his book "About Face."  He says it's a contraction of
'  the words "shaper" and "triangle."
' *************************************************************
'  Authors grant royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long

Private Const HTBOTTOMRIGHT = 17
Private Const WM_NCLBUTTONDOWN = &HA1

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   Call ReleaseCapture
   Call SendMessage(GetParent(UserControl.hWnd), _
      WM_NCLBUTTONDOWN, HTBOTTOMRIGHT, ByVal 0&)
End Sub

Private Sub UserControl_Resize()
   Static Ignore As Boolean
   Dim Size As Long

   If Not Ignore Then
      Ignore = True
      With UserControl
         Size = .TextHeight("op")
         On Error Resume Next
         With .Extender
            .Height = Size
            .Width = Size
         End With
      End With
      Ignore = False
   End If
End Sub

Private Sub UserControl_Show()
   With UserControl
      .AutoRedraw = True
      .ForeColor = vb3DHighlight
      UserControl.Print "o";
      .ForeColor = vb3DShadow
      .CurrentX = 0
      UserControl.Print "p"
   End With
End Sub
