VERSION 5.00
Object = "{307C5043-76B3-11CE-BF00-0080AD0EF894}#1.0#0"; "MSGHOO32.OCX"
Begin VB.Form FSizePaint 
   Caption         =   "Form1"
   ClientHeight    =   4425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6525
   LinkTopic       =   "Form1"
   ScaleHeight     =   4425
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      Height          =   840
      Left            =   1080
      TabIndex        =   2
      Top             =   840
      Width           =   1515
   End
   Begin VB.CheckBox Check1 
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Value           =   1  'Checked
      Width           =   195
   End
   Begin MsghookLib.Msghook Msghook1 
      Left            =   5280
      Top             =   360
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "   &Defer Painting During Resize"
      Height          =   195
      Left            =   300
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
End
Attribute VB_Name = "FSizePaint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************
'  Copyright 1999, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb/
' *************************************************************
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Const WM_ENTERSIZEMOVE = &H231
Private Const WM_EXITSIZEMOVE = &H232

Private m_Sizing As Boolean

Private Sub Form_Load()
   ' Spiff up demo
   Me.Caption = "Defer Paint and Resize Events"
   Set Me.Icon = Nothing
   
   ' Set up subclassing
   With Msghook1
      .HwndHook = Me.hWnd
      .Message(WM_ENTERSIZEMOVE) = True
      .Message(WM_EXITSIZEMOVE) = True
   End With
End Sub

Private Sub Form_Paint()
   If Check1.Value <> vbChecked Then
      ' Don't defer painting
      Call PaintTunnel
   ElseIf Not m_Sizing Then
      ' Do something complex
      Call PaintTunnel
   End If
End Sub

Private Sub Form_Resize()
   If Check1.Value <> vbChecked Or m_Sizing = False Then
      ' Do something complex
      With List1
         On Error Resume Next
         .Move .Left, .Top, Me.ScaleWidth - .Left * 2, Me.ScaleHeight - .Top * 2
         'Debug.Print .Left, .Top, Me.ScaleWidth - .Left * 2, Me.ScaleHeight - .Top * 2
         If Err Then .Visible = False Else .Visible = True
      End With
   End If
End Sub

Private Sub Label1_Click()
   ' Toggle deferment value
   Check1.Value = Not -(Check1.Value)
End Sub

Private Sub Msghook1_Message(ByVal msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
   ' Set flag appropriately, then call default
   ' window procedure.
   Select Case msg
      Case WM_ENTERSIZEMOVE
         m_Sizing = True
      Case WM_EXITSIZEMOVE
         m_Sizing = False
         Me.Refresh
         Form_Resize
   End Select
   result = Msghook1.InvokeWindowProc(msg, wp, lp)
End Sub

Private Sub PaintTunnel()
   Dim i As Integer
   Dim dX As Long
   Dim dY As Long
   Dim NewBrush As Long
   Dim cRect As RECT
   Const Shades As Long = 64
   '
   ' Get target dimensions and calculate shrinkage factors
   '
   Call GetClientRect(Me.hWnd, cRect)
   dX = cRect.Right / Shades \ 2
   dY = cRect.Bottom / Shades \ 2
   '
   ' Fill-it-up!
   '
   For i = Shades - 1 To 0 Step -1
      NewBrush = CreateSolidBrush(RGB((i + 1) * 4 - 1, 0, 0))
      Call FillRect(Me.hDC, cRect, NewBrush)
      Call DeleteObject(NewBrush)
      Call InflateRect(cRect, -dX, -dY)
   Next i
End Sub

