VERSION 5.00
Begin VB.Form frmGrab 
   Caption         =   "Form with sizing grip"
   ClientHeight    =   3435
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5085
   ClipControls    =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   3435
   ScaleWidth      =   5085
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Check1 
      Caption         =   "Display Sizing Grip"
      Height          =   315
      Left            =   180
      TabIndex        =   2
      Top             =   180
      Width           =   2715
   End
   Begin VB.Label lblGrip 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "p"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000010&
      Height          =   240
      Index           =   1
      Left            =   4380
      MousePointer    =   8  'Size NW SE
      TabIndex        =   1
      Top             =   3060
      Width           =   240
   End
   Begin VB.Label lblGrip 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "o"
      BeginProperty Font 
         Name            =   "Marlett"
         Size            =   12
         Charset         =   2
         Weight          =   500
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000014&
      Height          =   240
      Index           =   0
      Left            =   4740
      MousePointer    =   8  'Size NW SE
      TabIndex        =   0
      Top             =   3060
      Width           =   240
   End
End
Attribute VB_Name = "frmGrab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ReleaseCapture Lib "user32" () As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const WM_NCLBUTTONDOWN = &HA1
Private Const HTBOTTOMRIGHT = 17

Private Sub Check1_Click()
   ' Toggle "size grip" on/off
   lblGrip(0).Visible = CBool(Check1.Value)
   lblGrip(1).Visible = CBool(Check1.Value)
End Sub

Private Sub Form_Load()
   ' Basic demo niceties.
   Set Me.Icon = Nothing
   Me.Caption = "Size Gripper Demo"
   Check1.Value = vbChecked
   
   ' Define font for size grip labels. (Done here for
   ' demo, but probably easier at design-time.)
   Dim fnt As New StdFont
   With fnt
      .Name = "Marlett"
      .Bold = False
      .Size = 12
   End With
   
   ' Assign all relevant properties to size grip labels.
   With lblGrip(0)
      Set Font = fnt
      .AutoSize = True
      .Caption = "o"
      .ForeColor = vb3DHighlight
      .MousePointer = vbSizeNWSE
      .ZOrder
   End With
   With lblGrip(1)
      Set Font = fnt
      .AutoSize = True
      .Caption = "p"
      .ForeColor = vb3DShadow
      .MousePointer = vbSizeNWSE
      .ZOrder
   End With
End Sub

Private Sub Form_Resize()
   ' Position size grip labels at lower-right.
   With lblGrip(0)
      .Move Me.ScaleWidth - .Width, Me.ScaleHeight - .Height
   End With
   With lblGrip(1)
      .Move Me.ScaleWidth - .Width, Me.ScaleHeight - .Height
   End With
End Sub

Private Sub lblGrip_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
   ' Negate VB's call to SetCapture, and tell Windows
   ' that the user is trying to resize the form.
   ReleaseCapture
   SendMessage hwnd, WM_NCLBUTTONDOWN, HTBOTTOMRIGHT, ByVal 0&
End Sub

